/*
 * This is a WASP client.
 * BankClient.java
 * Created on December 13, 2001, 10:41 AM
 */
package com.systinet.demos.bank;

import org.idoox.webservice.client.WebServiceLookup;
import org.idoox.wasp.Context;

// imports of WASP security
import org.idoox.security.AuthResult;
import org.idoox.security.Credentials;
import org.idoox.security.PrincipalAuthenticator;
import org.idoox.security.client.Current;

/**
 * Bank client application
 */
public class BankClient
    extends Object
{
    /**
     * Runs the demo on the client-side
     * @param args the command line arguments
     */
    public static void main (String args[])
        throws Exception
    {
        String username = args[0];
        String password = args[1];

        if(username == null)
          username = "john";

        if(password == null)
          password = "password";

        System.out.println("Authenticating user "+username);
        // init the lookup
        WebServiceLookup lookup = (WebServiceLookup)
            Context.getInstance(Context.WEBSERVICE_LOOKUP);

        // obtain and set the crededentials
        Current current = Current.getInstance();
        PrincipalAuthenticator auth = current.getAuthenticator();
        AuthResult result = auth.authenticate(username, password.getBytes());
        if (result.resultCode != AuthResult.AUTH_STATUS_SUCCESS) {
            System.err.println("Unable to authenticate");
            return;
        }
        current.setCredentials(new Credentials[] { result.creds });

        // get the proxy to the Web Service from the lookup
        Account account = (Account)
            lookup.lookup("http://localhost:6060/AccountImpl/", Account.class);
        // now, call the methods on your Web Service interface
        System.out.println("Account #" + account.getAccountNumber() + " created.");
        System.out.println("Putting $10 000 on account #" +
                           account.getAccountNumber() + " .");
        account.deposit(10000);
        System.out.println("Getting $7 000 from account #" +
                           account.getAccountNumber() + " .");
        account.withdraw(7000);
        System.out.println("Account #" + account.getAccountNumber() + " balance is "
                           + account.getBalance());
        account.close();
    }
}
